import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "className", "disabled", "element", "icon", "size", "color", "tint", "selected", "type", "onMouseUp", "onMouseLeave", "processing"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

import cx from 'classnames';
import React, { forwardRef, useImperativeHandle, useRef } from 'react';
import Box from '../box';
import buttonTheme from '../button/theme.css';
import Icon from '../icon';
import LoadingSpinner from '../loadingSpinner';
import theme from './theme.css';
var IconButton = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _cx;

  var children = _ref.children,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? '' : _ref$className,
      disabled = _ref.disabled,
      _ref$element = _ref.element,
      element = _ref$element === void 0 ? 'button' : _ref$element,
      icon = _ref.icon,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 'medium' : _ref$size,
      _ref$color = _ref.color,
      color = _ref$color === void 0 ? 'neutral' : _ref$color,
      _ref$tint = _ref.tint,
      tint = _ref$tint === void 0 ? 'darkest' : _ref$tint,
      selected = _ref.selected,
      _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'button' : _ref$type,
      onMouseUp = _ref.onMouseUp,
      onMouseLeave = _ref.onMouseLeave,
      _ref$processing = _ref.processing,
      processing = _ref$processing === void 0 ? false : _ref$processing,
      others = _objectWithoutProperties(_ref, _excluded);

  var buttonRef = useRef(null);
  useImperativeHandle(ref, function () {
    return buttonRef.current;
  });

  var blur = function blur() {
    var currentButtonRef = buttonRef.current;

    if (currentButtonRef !== null && currentButtonRef !== void 0 && currentButtonRef.blur) {
      currentButtonRef.blur();
    }
  };

  var handleMouseUp = function handleMouseUp(event) {
    blur();

    if (onMouseUp) {
      onMouseUp(event);
    }
  };

  var handleMouseLeave = function handleMouseLeave(event) {
    blur();

    if (onMouseLeave) {
      onMouseLeave(event);
    }
  };

  var classNames = cx(buttonTheme['button-base'], theme['icon-button'], theme["is-".concat(size)], (_cx = {}, _defineProperty(_cx, theme['is-disabled'], disabled), _defineProperty(_cx, theme['is-processing'], processing), _defineProperty(_cx, theme['is-selected'], selected), _cx), className);

  var props = _objectSpread(_objectSpread({}, others), {}, {
    ref: buttonRef,
    className: classNames,
    disabled: element === 'button' ? disabled : undefined,
    element: element,
    onMouseUp: handleMouseUp,
    onMouseLeave: handleMouseLeave,
    type: element === 'button' ? type : undefined,
    'data-teamleader-ui': 'icon-button'
  });

  if (processing) {
    return /*#__PURE__*/React.createElement(Box, props, /*#__PURE__*/React.createElement(LoadingSpinner, {
      className: theme['spinner'],
      color: color === 'white' ? 'neutral' : color,
      size: size === 'small' ? 'small' : 'medium',
      tint: tint
    }));
  }

  return /*#__PURE__*/React.createElement(Box, props, /*#__PURE__*/React.createElement(Icon, {
    color: color === 'white' ? 'neutral' : color,
    tint: color === 'white' ? 'lightest' : tint
  }, icon), children);
});
IconButton.displayName = 'IconButton';
export default IconButton;